

% new growing window approximation (used to model the segments)
gw = GrowingWindow(2);

%new sliding window approximation (used for segmentation)
sw = SlidingWindow(2,10);

for i=0:1e4
   
    % generate time series data
    y = sin(i/5);
    
    % update approximation
    gw.update(y);
    sw.update(y);

    os = sw.getOrthogonalCoefficients();
    slope = os(2);
    curve = os(3);
    segmentlength = gw.getNumSamples();

    % check coefficients of sliding window to detect local maxima
    % and size of current growing window to avoid short segments
    if abs(slope) < 0.01 && curve < -0.0045 && segmentlength > 10

            % display information about current segment
            og = gw.getOrthogonalCoefficients();

            msg = ['Segment at ' num2str(i - 15) ': avg=' num2str(os(1)) ...
                    ', slope=' num2str(os(2)) ', curve=' num2str(os(3)) ', ...'];
            disp(msg);

            % reset growing window approximation at start of new segment
            gw.reset();
            segmentlength=0;
    end
        
    % restart sliding window approximation to avoid numerical problems
    if mod(i,1000) == 0
        sw.reset(); 
    end
end
    

   